package com.sun.org.apache.bcel.internal.generic;

import java.io.IOException;
import java.io.DataOutputStream;

public class GOTO extends GotoInstruction implements VariableLengthInstruction
{
    GOTO() {
    }
    
    public GOTO(InstructionHandle target) {
        super((short)167, target);
    }
    
    @Override
    public void dump(DataOutputStream out) throws IOException {
        super.setIndex(this.getTargetOffset());
        short _opcode = this.getOpcode();
        if (_opcode == 167) {
            super.dump(out);
        }
        else {
            super.setIndex(this.getTargetOffset());
            out.writeByte((int)_opcode);
            out.writeInt(super.getIndex());
        }
    }
    
    @Override
    protected int updatePosition(int offset, int max_offset) {
        int i = this.getTargetOffset();
        this.setPosition(this.getPosition() + offset);
        if (Math.abs(i) >= 32767 - max_offset) {
            super.setOpcode((short)200);
            short old_length = (short)super.getLength();
            super.setLength(5);
            return super.getLength() - old_length;
        }
        return 0;
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitVariableLengthInstruction(this);
        v.visitUnconditionalBranch(this);
        v.visitBranchInstruction(this);
        v.visitGotoInstruction(this);
        v.visitGOTO(this);
    }
}
